#include "workflow_graph.hpp"

namespace xios
{

  std::unordered_map <StdString, vector <int > > CWorkflowGraph::mapFieldToFilters;
  std::unordered_map <int, StdString> CWorkflowGraph::mapFilters;
  std::unordered_map <int,vector<Time> > CWorkflowGraph::mapFilterTimestamps;
  set<Time>  CWorkflowGraph::timestamps;

  vector <StdString> CWorkflowGraph::filters;
  vector <StdString> CWorkflowGraph::fields;
  vector <pair<int, int> > CWorkflowGraph::fieldsToFilters;

  CWorkflowGraph::CWorkflowGraph()
  { }

  /*!
   * Reorganize information collected by XIOS for visualization.
   */
  void CWorkflowGraph::buildStaticWorkflow()
  TRY
  {
    // Create a list of filters (graph nodes)
    size_t filterIdx = 0;
    filters.resize(mapFilters.size());
    for (auto it=mapFilters.begin(); it != mapFilters.end(); it++)
    {
      filters[it->first]=it->second;
    }

    // Create a list of fields and their filter connectivity (graph edges and edge-to-node connectivity)
    for (auto it=mapFieldToFilters.begin(); it != mapFieldToFilters.end(); it++)
    {
      for (size_t i = 0; i < (it->second.size() - 1); i+=2)
      {
        fieldsToFilters.push_back(make_pair(it->second[i],it->second[i+1]));
        fields.push_back(it->first);
      }
    }
  }
  CATCH

}
